#import <space.h>		  //  Space features
#import <gui.h>
			 
#import "WrappedListGrid2d.h"
#import "Culture.h"

typedef enum { safe, riotous } ExtremeType;

int numFeatures, numTraits, pplPerCell;
id observerSwarm, modelSwarm;

@interface Citizen: SwarmObject
{
  double unhappiness;		
  int x, y, workx, worky;
  int idnum;
  char  myName[20];

  int age;	
 
  float randomMoveProbability;		
  double discontentHere;
  double probRulerBad;
  double personalCondition;
  double threshold;
  WrappedListGrid2d *homeGrid, *workGrid;			
  int worldXSize, worldYSize; 
  int workXSize, workYSize;
  			
  Color citizenColor;
  int periodsProtesting;
  int protesting;
  int protestinglag1;
  int radius;
  
  id culture;
  id <Map> contacts;
  id <List> listOfCandidates;
  id <List>safetyList;

  int acquaintance[20], same[20], identical[20];
  int acquaintanceMT, sameMT, identicalMT;
  int numTests, numInteractions, acquaintanceTotal, sameTotal, identicalTotal;

}

+ (void) setNumFeatures: (int) f;
+ (void) setNumTraits: (int) t;
+ (void) setPplPerCell: (int)t;
+ (void) setObserverSwarm: observer;
+ getObserverSwarm;
+ (void) setModelSwarm: (id) model;
+(int) getNumFeatures;
+(int) getNumTraits;

- setWorkGrid: (WrappedListGrid2d *)w HomeGrid: (WrappedListGrid2d *)h; 

- createEnd;

- setName: (const char*) name;

- setPersonalCondition: (double)c;

- setVision: (int) r;
- setRandomMoveProbability: (float)p;
- setHomeX: (int)x Y: (int)y;	
- setWorkX: (int)workx Y: (int)worky;		
- setColor: (Color)c;			  

- init: (int) n ;

-(double) getPerceivedAcquaintance;
-(double) getPerceivedHarmony;
-(double) getPerceivedIdentical;



-(int) getIDNumber;

-getContacts;
-(id)getCulture;

-(int)getFeature: (int) f;

- sayHi;

- step;

- chooseLocation;
- initializeIVars;

-(Citizen *) selectADiscussantInMilieu: (id) world;
- adjustOpinionAgainst: other;

- reportObservations;

- (double)findExtremeType: (ExtremeType) type X: (int *)x Y: (int *)y;

- (Citizen *) findMostAppealingIn: listOfCandidates;

- drawSelfOn: (id <Raster>)r;

@end

