#import "Citizen.h"
#import <random.h>
#import <math.h>
#import "Culture.h"
#import "ModelSwarm.h"
#import "Cell.h"
#import "Attribute.h"


@implementation Citizen

- createEnd
{
  if (workGrid == nil || homeGrid == nil)
    [InvalidCombination
      raiseEvent: "Agent was created without a world \n"];
  return self;				
}


+ (void) setNumFeatures: (int) f
{
   numFeatures=f;
}

+ (void)  setNumTraits: (int) t
{
   numTraits = t;
}

+ (void) setPplPerCell: (int) t
{
   pplPerCell = t ; 
}


+ (void) setObserverSwarm: observer
{
  observerSwarm = observer;
}

+ getObserverSwarm
{
  return observerSwarm;
}

+ (void) setModelSwarm: (id) model
{
  modelSwarm=model;
}

+(int) getNumFeatures
{
   return numFeatures;
}

+(int) getNumTraits
{
   return numTraits;
}

- init: (int) n
{
  int i;
  worldXSize = [homeGrid getSizeX];
  worldYSize = [homeGrid getSizeY];
  workXSize =  [workGrid getSizeX];
  workYSize =  [workGrid getSizeY];
  idnum     =  n;
 
  culture   =  [Culture create: [self getZone]];
  [culture initFeatures: numFeatures Traits: numTraits];

  contacts  = [[Map createBegin: [self getZone]] createEnd];
  listOfCandidates = [List create: [self getZone]];
   safetyList = [List create: [self getZone]]; 

  for(i=0; i<numFeatures; i++)
    {
      [modelSwarm incrFeature: i Value: [culture getFeature: i]];
    }

  numTests = 0;

  for(i=0; i < 20; i++)
    {
      acquaintance[i]  =0;
      identical[i] = 0;
      same[i]=0;

    }
  sameMT = 0;
  identicalMT = 0;
  acquaintanceMT = 0;
  
  sameTotal=0;  
  acquaintanceTotal=0;
  identicalTotal=0;
  return self;
}

- setWorkGrid: (WrappedListGrid2d *)w HomeGrid: (WrappedListGrid2d *)h
{
  if (workGrid != nil || homeGrid != nil)
    {
      [InvalidArgument
        raiseEvent:
          "You can only set the world  of a agent at creation time\n"];
    }
  workGrid = w;
  homeGrid = h;

  return self;
}

- setRandomMoveProbability: (float)p
{
  randomMoveProbability = (float) p;
  return self;
}

-setName: (const char *) name;
{
  strcpy(myName,name);
  return self;
}

-setVision: (int) r
{
  radius=r;
  return self;
}

-setPersonalCondition: (double) c
{
   personalCondition=c;
   return self;
}


- setHomeX: (int)inX Y: (int)inY
{
  x = inX;
  y = inY;
  [homeGrid addFirst: self atX: inX Y: inY];
  return self;
}

- setWorkX: (int)inX Y: (int)inY
{
  workx = inX;
  worky = inY;
  //  [workGrid addFirst: self atX: inX Y: inY];
  return self;
}

-sayHi
{
 printf("Citizen name is %s  Number is %d \n", myName, idnum);
 [culture print];
 return self;
}

-(double) getPerceivedAcquaintance{
  double totalHistory;  
  double acquaintanceMA;

  totalHistory= (double)acquaintanceTotal/(double)(numTests);

  //   acquaintanceMT=0;

 if( numTests < 20)
    {
  //     for(i=0; i < numTests; i++)
//       acquaintanceMT = acquaintanceMT + acquaintance[i];
    
      acquaintanceMA= (double)acquaintanceMT/(double) numTests;
    }
     
 else
   {
 //    for (i=0; i<20; i++)
    
//         acquaintanceMT = acquaintanceMT+ acquaintance[i];   
    
        acquaintanceMA = (double)acquaintanceMT/20.0 ;
    }
 //  printf("Acq Total  %d  AVG %f   MA Total  %d   AVG %f \n", acquaintanceTotal, totalHistory, acquaintanceMT, acquaintanceMA);

  return acquaintanceMA;
}

-(double) getPerceivedHarmony
{
 double sameHistory;
 double sameMA = 0;
 
 if( numInteractions == 0) return 0;

 if( numInteractions  < 20)
    {
//       for(i=0; i < numInteractions; i++)
// 	   sameMT = sameMT + same[i-1];
    
           sameMA= (double)sameMT/(double) (numInteractions*numFeatures);
    }
 else
   {
//     for (i=0; i<20; i++)
//        sameMT = sameMT + same[i-1];
    
       sameMA= (double)sameMT/(double)(20 * numFeatures);
   }

  sameHistory= (double)sameTotal/(double)((numInteractions)* numFeatures);

  //   printf("HARMONY sameTotal %d TotalHisory %f sameMT %d   same MA %f  \n",sameTotal, sameHistory, sameMT, sameMA);
  return sameMA;
}


-(double) getPerceivedIdentical
{
   double totIdent;
   double identicalMA = 0;
 
   if( numInteractions == 0) return 0;

   if( numInteractions  < 20)
    {
   //    for(i=0; i < numInteractions; i++)
// 	   identicalMT = identicalMT + identical[i-1];
           identicalMA= (double)identicalMT/(double) numInteractions;
    }
 else
   {
//     for (i=0; i<20; i++)
//         identicalMT = identicalMT + identical[i-1];
 
       identicalMA= (double)identicalMT/(double) 20;
    }

   totIdent=(double)identicalTotal/(double)numInteractions;
   //    printf("Total Identical %d  avg %f numInt %d MAIDentical %d mavg %f\n",identicalTotal, totIdent, numInteractions, identicalMT, identicalMA);
   return identicalMA;  
}

-(int) getIDNumber
{
  return idnum;
}

-getContacts {
  return contacts;
}

-(id)getCulture {
  return culture;
}

-(int)getFeature: (int) f
{
  return [culture getFeature: f];
}



-(double)similarityWith: (id) other {
  return [culture similarityWith: [other getCulture]];
}


- chooseLocation
{
  int newx, newy;    
  newx=x; newy=y;


  if (protestinglag1==0 && discontentHere >0 )
    //go to place with lower discontent than here
    {
      double newDiscontent=[self  findExtremeType: safe X: &newx Y: &newy];

      printf("oldDiscontent %f NewDiscontent safetylover %f at position %d,%d \n",discontentHere, newDiscontent, x,y);
      if (newDiscontent < discontentHere)
	{
	  [workGrid deleteObject: self atX: x Y: y];
        
	  [workGrid addFirst: self atX: newx Y: newy];
	}
      printf("Nonrotester moved from %d,%d to %d,%d oldval %f newval %f \n", x,y,newx,newy, discontentHere, newDiscontent);
      x=newx;
      y=newy;
    }
  if (protestinglag1==1 && discontentHere <100 )
    //go to  place with higher discontent than here
    {
    
      double newDiscontent=[self findExtremeType: riotous X: &newx Y: &newy];
      printf("RiotLover: oldDiscontent %f NewDiscontent  %f at position %d,%d \n",discontentHere, newDiscontent, x,y);
      if (newDiscontent > discontentHere)
	{
	  [homeGrid deleteObject: self atX: x Y: y];
	  [homeGrid addFirst: self atX: newx Y: newy];
	}
      printf("Protester moved from %d,%d to %d,%d oldval %f newval %f \n", x,y,newx,newy, discontentHere, newDiscontent);
      x=newx;
      y=newy;
    }
     
  return self;
}


- initializeIVars
{
  return self;
}

-step
{ 
  id other;
  //   [self initializeIVars];

  //   [self chooseLocation];
  other= [self selectADiscussantInMilieu: homeGrid];
  if(other != nil)
    [self adjustOpinionAgainst: other];
  [self reportObservations];

  [[homeGrid getObjectAtX: x Y:y] drawSelfOn: observerSwarm ];

  return self;
}


-(Citizen *) selectADiscussantInMilieu: (id) world
{
  //here is Riolo's way
#ifdef AXELROD

  int x2, y2 = 0;
  id c;
  int xsize, ysize;  

  xsize=[world getSizeX]; 
  ysize=[world getSizeY];


#ifndef WRAPAROUND 
  if(pplPerCell==1)
    {
    do {
      if ( [uniformUnsRand getUnsignedWithMin: 0 withMax:1] == 0 ) 
	{
	  x2 = x;
	  y2 = y +([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1);
	} 
      else 
	{
	  x2 = x + ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1);
	  y2 = y;
	}
    } while (x2 < 0 || x2 >= xsize || y2 < 0 || y2 >= ysize );	
    c = [world selectRandomMemberX: x2 Y: y2];
    //printf("in citizen %d I found: \n", idnum);
    //	  [c sayHi];
    }
  // need to find a way to do this that doesn't take so many calls to random generator
  // keeps us in bounds!
    
    
  else
    {
      //stay within current cell to find partner with probability .2
      if( [uniformDblRand getDoubleWithMin: 0 withMax: 1]< .2)
	{
	  x2=x;
	  y2=y;
	  [world  deleteObject: self atX:  x Y: y]; 
	  c = [world selectRandomMemberX: x2 Y: y2];
	  [world  addLast: self atX:  x Y: y];
	}
      //with a certain probability, choose within own cell
      else
	{
	  do {
	    if ( [uniformUnsRand getUnsignedWithMin: 0 withMax:1] == 0) {
	      x2 = x;
	      y2 = y + ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1);
	    } else {
	      x2 = x + ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1);
	      y2 = y;
	    }
	  } while (x2 < 0 || x2 >= xsize || y2 < 0 || y2 >= ysize );

	  c = [world selectRandomMemberX: x2 Y: y2];

	}
    }
#else
  if(pplPerCell==1)
    {
      if ( [uniformUnsRand getUnsignedWithMin: 0 withMax:1] == 0) 
	{
	  x2 =  x;
	  y2 = (y + ysize+ ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1))%ysize;
	} 
      else 
	{
	  x2 = (x +xsize + ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1)) %xsize;
          y2 = y;
      }
      c = [world selectRandomMemberX: x2 Y: y2];
    }
  else
    {
      if( [uniformDblRand getDoubleWithMin: 0 withMax: 1]< .5)
	{
	  x2=x;
	  y2=y;
	  [world  deleteObject: self atX:  x Y: y]; 
	  c = [world selectRandomMemberX: x2 Y: y2];
	  [world  addLast: self atX:  x Y: y];
	}
      else
	{
	  if ( [uniformUnsRand getUnsignedWithMin: 0 withMax:1] == 0) 
	    {
	      x2 =  x;
	      y2 = (y + ysize+ ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1))%ysize;
	    } 
	  else {
	    x2 = (x +xsize + ([uniformUnsRand getUnsignedWithMin: 0 withMax:1]  ? -1 : 1)) %xsize;
	    y2 = y;
	  }
	  c = [world selectRandomMemberX: x2 Y: y2];
    }
#endif
      return c;
    }

#endif

#ifdef JOHNSON

  //int i, j;
  int nx, ny;
  int xsize, ysize;
  xsize=[world getSizeX]; ysize=[world getSizeY];

  [listOfCandidates removeAll];
  //temporarily remove self from world while searching for Discussants
  [world  deleteObject: self atX:  x Y: y]; 

#ifndef WRAPAROUND 

  nx=x-1; ny=y;

  if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];


  if(pplPerCell > 1)
	{
         nx=x; ny=y;
         if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
         [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];
	}
  nx=x+1; ny=y;
  if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

  nx=x; ny=y-1;

  if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];
  nx=x; ny=y+1;

  if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

//   For Moore Neighborhood
//   for(i=-1;i<2;i++)
//     for(j=-1;j<2;j++)
//       {
// 	if((nx= (x + i))>=0 && (nx < xsize) && ((ny=y+j)>=0 && ny < ysize ))
// 	  [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];
//       }


 

#else
  nx=(x +xsize-1)% xsize; ny=y;

  [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

  nx=x; ny=y;
  if((nx >= 0) && (nx < xsize) && (ny>=0) && (ny < ysize) )
    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

  nx=(x+xsize+1)%xsize; ny=y;
  [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

  nx=x; ny=(y+ysize-1)%ysize;

  [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];

  nx=x; ny=(y+ysize+1)%ysize;

  [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];



  //Use following for full Moore Neighborhood plus agent's current location
  //      for(i=-1;i<2;i++)
  // 	for(j=-1;j<2;j++)
  // 	  {
  // 	    nx=(x + xsize + i) % xsize;
  // 	    ny=(y + ysize +j) % ysize;

  // 	    [listOfCandidates addLast: [world selectRandomMemberX: nx Y: ny]];
  // 	  }

#endif       

  [world  addLast: self atX:  x Y: y]; 
              
  return [self  findMostAppealingIn: listOfCandidates];
}
#endif

- adjustOpinionAgainst: other
{
  int featureToTest;

  int interactionpoint = (20+numInteractions) % 20; 
  int timepoint= (20+numTests) % 20;
#ifdef JOHNSON
  id aContact;
#endif
  

  featureToTest= [uniformUnsRand getUnsignedWithMin: 0 withMax: numFeatures-1];
  //  printf("other number %d \n",[other getIDNumber]);
  // [[other getCulture] print];
  //with probability equal to the extent of our agreement
  numTests++;
 
  acquaintanceMT=acquaintanceMT-acquaintance[timepoint]; 	
  

  if( [[other getCulture] getFeature: featureToTest]== [culture getFeature: featureToTest] )
    
    {
      int indicator[numFeatures];
      int diff[numFeatures];
      int * otherCulture;
      int * ownCulture;
      int i,j,k = 0;
   
      numInteractions++;

      sameMT= sameMT - same[interactionpoint];
      identicalMT = identicalMT - identical[interactionpoint];

      acquaintance[timepoint]=1  ;
      acquaintanceMT=acquaintanceMT + 1;
      
      acquaintanceTotal += 1;
      // printf( "Acq[i] = %d and AcqTotal= %d \n", acquaintance[ (20+numTests-1) % 20], acquaintanceTotal);

      [modelSwarm incrNumberOfInteractionsThisStep];     
       
      otherCulture = [[other getCulture] getCultureArray];
      ownCulture = [culture getCultureArray];  

      for (i=0; i < numFeatures; i++)
	{
	  if ( (diff[i] = ownCulture[i]  - otherCulture[i]) != 0 )
	    {
	      indicator[k] = i;
	      k++;
	    }
	}
      same[interactionpoint]= numFeatures-k;
      sameTotal =sameTotal + numFeatures - k;
      sameMT= sameMT+ numFeatures - k;

#ifdef JOHNSON
      if((aContact=[contacts at: other])==nil)
	{
	  id attribute;
	  attribute = [[Attribute createBegin:[self getZone]] createEnd];
	  [attribute setSimilarity: (numFeatures -k)];
	  [contacts at: other insert: attribute];
	  // printf("Attribute: new customer \n")  ;
	}
      else
	{
	  [aContact setSimilarity: (numFeatures -k)];
	}
#endif
      if (k > 0)
	{
	  int newCultureValue = 999;
	  identical[interactionpoint]=0;
	  j= indicator[ [uniformUnsRand getUnsignedWithMin:0 withMax: k-1] ];
	   
	  //         if(diff[j] > 0 ) newCultureValue=ownCulture[j] -1;
	  //  	   else if (diff[j] < 0)   newCultureValue= ownCulture[j]+1;
	  // 	   else printf("You fucked up");
	  //standard Axelrod model:

	  newCultureValue=otherCulture[j];
 
	  [modelSwarm incrFeature: j Add: newCultureValue  Subtract: ownCulture[j]];
	  ownCulture[j]=newCultureValue;
	}
      else
	{
	  identical[interactionpoint ] = 1;
	  identicalMT = identicalMT + 1;
	  identicalTotal = identicalTotal+1;
	}
    }
  else
    {
      acquaintance[timepoint]= 0 ;
    }
    
  return self;
}

- reportObservations
{ 
        [modelSwarm registerAcquaintance: [self getPerceivedAcquaintance]];
        
        [modelSwarm registerHarmony: [self getPerceivedHarmony] ];
	[modelSwarm registerIdentical: [self getPerceivedIdentical]  ];
    return self;
}  


- (Citizen *) findMostAppealingIn: list
 {
     int  bestValue;
     id  anOption;
     id aCitizen;
     int offset;
     id index;    
     id bestDiscussant;     
	int strangerValue= (int)( 0.5* numTraits) ; 
      
     //printf("strangerValue %d %f \n",strangerValue, 0.5*numTraits);   

     index = [list  begin: [self getZone]];

     aCitizen =  [index next];
     if((anOption =[contacts at:  aCitizen ]) != nil)
       bestValue= [anOption getSimilarity];
     else
       bestValue = strangerValue;
     
     [safetyList addLast: aCitizen];

     while( (aCitizen=[index next])!= NULL ) 
	   {
             int  valueHere;
             BOOL hereIsBetter, hereIsEqual;

	     if((anOption=[contacts at: aCitizen]) != NULL)
	       valueHere= [anOption getSimilarity];
	     else
	       valueHere = strangerValue;   
	       
       	 hereIsBetter= (valueHere > bestValue);
	 // printf("safe, %d, %d, %d \n", valueHere, bestValue, hereIsBetter);
  
    
             hereIsEqual = (valueHere == bestValue);
          
             if (hereIsBetter) 
	       {	      // this spot more extreme
              
                 [safetyList removeAll];
                 [safetyList addLast: aCitizen];  // now list only has the one new cell

                 bestValue = valueHere;   // update information
            }
          

             if (hereIsEqual) 
	       {
                 [safetyList addLast: aCitizen]; // add to the end of the list
		 // printf("Here is equal");
		 // xprint(safetyList);
	       }
         }
   
  
//   // printf("---------\n");

     // choose a random citizen from the list
     if( [safetyList getCount] >1)
       {
     offset = [uniformIntRand getIntegerWithMin: 0L 
                            withMax: ([safetyList getCount] - 1)];

      bestDiscussant = [safetyList atOffset: offset];
       }
     else bestDiscussant = [safetyList atOffset: 0];
     [safetyList removeAll];
     [index drop];

     return bestDiscussant;

}

- (double)findExtremeType: (ExtremeType) type X: (int *)x Y: (int *)y
{
   return 999.0;

}

- setColor: (Color)c
{
  citizenColor = c;
  return self;
}




- drawSelfOn: (id <Raster>)r
{

  [r drawPointX: x Y: y Color: citizenColor];
  return self;
}

@end
