#import "ListWrapper.h"
#import <math.h>
#import <misc.h>
#import "Citizen.h"
#import "ObserverSwarm.h"
//#include <dmalloc.h>

@implementation ListWrapper

- setX: (int) theX Y: (int) theY
{
  x=theX;
  y=theY;
  return self;
}

- setX: (int)theX
{
    x = theX;
    return self;
}
- setY: (int)theY
{
    y = theY;
    return self;
}

-setList:  (id<List>) aList
{
    list=aList;
    return self;
}


// pj Note: This is a nondestructive copy of the input list aList
// into the wrapped list "list"
-setNewList: (id<List>) aList
{
    id index;
    id obj;
    index=[aList begin: [self getZone]];
    while( (obj=[index next])!= NULL)
      {
	[list addLast: obj];
      }
    return self;
}

-(id <List>)getList
{
    return list;
}

- (int)getX
{ 
    return x;
}

- (int)getY
{
    return y;
}

-(int)getPopulationLevel
{
  return [list getCount];
}


@end 


@implementation ApplicationSpecific

- createEnd
{ 
   [super createEnd];
   [self setupFeatures]; 
   return self;
}

- setupFeatures
{
  numFeatures= [Citizen getNumFeatures];  
  numTraits = [Citizen getNumTraits];
  observerSwarm = [Citizen getObserverSwarm];
  sumFeature =  [[self getZone] allocBlock: numFeatures * sizeof(int)];  
  avgFeature =  [[self getZone] allocBlock: numFeatures * sizeof(double)];  
  return self;
}


// -(int) addOneProtester
// {
//   numProtesters=numProtesters + 1; 
//   [self setFlag];
//   return numProtesters;
// }

// -(int) removeOneProtester
// {
//   numProtesters=numProtesters -1;
//   [self setFlag];
//   return numProtesters;
// }

-(int) getSumFeature: (int) f
{
  id index;
  id aPerson;
  int populationLevel;
  sumFeature[f] = 0;
  index=[list begin: [self getZone]];
  while((aPerson=[index next])!=NULL)
    { 
      int value;
      if ((value=[aPerson getFeature: f]))
           sumFeature[f]=sumFeature[f] + value;
      // printf("Value is %d", value);
	  ;
    }
  [index drop];

  //now update percent protesting, just for record keeping
  if((populationLevel=[list getCount])==0) 
	      avgFeature[f]=255;
	    else
	      avgFeature[f]=(double)sumFeature[f]/(double)populationLevel ;
  return sumFeature[f];
}

-(double) getAvgFeature: (int) f
{
  [self getSumFeature: f];
  return avgFeature[f];
}

//note that assumes that figure is up to date. could do [self getSumFeature:f] first to be sure...


- initializeAllValues
{
   int i;
   for (i=0; i< numFeatures; i++)
     {   
     sumFeature[i]=0;
     avgFeature[i]=0;
     }
   return self;
}

- drawSelfOn: (id <Raster>)r
{
  float color;
  int f;

  for(f=0; f< numFeatures; f++)
    { 
      color=  66 + 80* (double) [self getAvgFeature: f]/ (double) (numTraits-1);
      [[Citizen getObserverSwarm] drawFeature: f PointX: x Y: y Color: color];
    }
  return self;
}

- drawSelfOn2: (id <Raster>) r
{
  return self;
}

- (int) getOutputValue
{
  int f=0;
  return (int) avgFeature[f];
}

@end
