#import "MyArguments.h"
#import <stdlib.h>

#import <objectbase.h>    //for probeMap
#import <objectbase/ProbeMap.h>

@implementation MyArguments

+ createBegin: aZone
 {
   static struct argp_option options[] = {
     {"pplPerCell",'n',"N", 0, "Set pplPerCell", 5},
     {"inputfile", 'I',"filename",0,"set fn",6},
     {"run",'R',"RunNumber",0,"Run is...",7},
     {"seed",'S',"SeedNumber",0,"Seed",8},
     {"vision",'v',"VisionRadius",0,"Vision to radius squares",9},
     {"worldsize",'w',"WorldSize",0,"Dimension w and h",10},
     {"numTraits",'T',"numTraits",0,"N of Traits",11},
     {"numFeatures",'F',"numFeatures",0,"N of Features",12},
     { 0 }
   };
   
   MyArguments *obj = [super createBegin: aZone];

   [obj addOptions: options];

   
  obj->numWorkplaces = 5;

  obj->worldXSize = 10;
  obj->worldYSize = 10;

  obj->pplPerCell= 2;
  obj->workXSize=5;
  obj->workYSize=5;
  obj->numFeatures=5;
  obj->numTraits = 3;

  obj->visionRadius=3; 
  obj->randomizeCitizenUpdateOrder = YES;
  obj->oneAtATime = NO;

  obj->randomMoveProbability = 0.0;
  
  obj->randomSeed=7777777; 
  
   return obj;
 }

- (BOOL)toggleOneAtATime
{
    oneAtATime = 
    ( (oneAtATime == NO) ? YES : NO );
  return (oneAtATime);
}

- (BOOL)toggleRandomOrder
{
  randomizeCitizenUpdateOrder = 
    ( (randomizeCitizenUpdateOrder == NO) ? YES : NO );
  return (randomizeCitizenUpdateOrder);
}

- (BOOL) getToggleRandomOrder
  {return randomizeCitizenUpdateOrder;}

- (BOOL) getToggleOneAtATime
  {return oneAtATime;}




- init
{
  id probeMap;

  probeMap = [EmptyProbeMap createBegin: [self getZone]];
  [probeMap setProbedClass: [self class]];
  probeMap = [probeMap createEnd];

  // Add in a bunch of variables, one per simulation parameter

  [probeMap addProbe: [probeLibrary getProbeForVariable: "pplPerCell"
				    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: "visionRadius"
 				    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: "worldXSize"
				    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: "worldYSize"
				    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: "numFeatures"
				     inClass: [self class]  ]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: "numTraits"
   				    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForMessage: 
                                      "toggleRandomOrder" 
                                    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForMessage: 
                                      "toggleOneAtATime" 
                                    inClass: [self class]]];

  [probeMap addProbe: [probeLibrary getProbeForVariable: "randomMoveProbability"
				    inClass: [self class]]];

  [probeMap addProbe: [probeLibrary getProbeForVariable: "randomSeed"
				    inClass: [self class]]];
  [probeLibrary setProbeMap: probeMap For: [self class]];

  return self;

}


- (int)parseKey: (int) key arg: (const char*) arg
 {
   if (key == 'n')
     {
       pplPerCellArg = arg;
       pplPerCell = atoi(pplPerCellArg);
       return 0;
     }
   if (key == 'v')
     {
       visionRadiusArg = arg;
	visionRadius=atoi(arg);
       return 0;
     }
   if (key == 'w')
     {
       worldSizeArg = arg;
       worldXSize= atoi(worldSizeArg);
       worldYSize= atoi(worldSizeArg);
       return 0;
     }
   if (key == 'F')
     {
       numFeatures =  atoi (arg);
       return 0;
     }
   if (key == 'T')
     {
       numTraits = atoi (arg);
       return 0;
     }
   if (key == 'S')
     {
       seedArg = arg;
	randomSeed=atoi(seedArg);
       return 0;
     }
   if (key == 'I')
     {
       printf("here is an I \n");
       return 0;
     }
   if (key == 'R')
     {
       runArg = arg;
       return 0;
     }
   else
     return [super parseKey: key arg: arg];
 }

- (int) getPplPerCellArg
 {
   int num=-1;
   if(pplPerCellArg)
   num = atoi(pplPerCellArg); 
   return num;
 }

- (int) getVisionRadiusArg
{
  int num=-1;
  if(visionRadiusArg)
    num = atoi (visionRadiusArg);
  return num;
}

- (int) getRunArg
{
  int num=-1;
  if(runArg)
    num = atoi (runArg);
  return num;
}

- (int) getSeedArg
{
  int num = -1;
    if(seedArg)
    num = atoi (seedArg);
  return num;
}


-sayHello
{
    printf("You are a dirty scoundrel");
    return self;
}




@end
