#import "NewEZGraph.h"
#import <simtools.h>
#import <simtools/OutFile.h>
#import <analysis.h>
#import <misc.h>


#define NUMCOLORS 12
const char graphColors[NUMCOLORS][16] =
//    { "Red",     "Green",  "Yellow",    "Pink",      "SeaGreen",
//      "Magenta", "Purple", "DarkGreen", "Goldenrod", "Black" };
        { "Red",   "Blue",   "Orange", "DarkGreen", "Magenta",  
"Purple",
        "Green", "Yellow", "Cyan",   "SeaGreen",  "Goldenrod", "Black"
};  

@implementation NewEZGraph

// internal method called by createSequence:withFeedFrom:andSelector
- createGraphSequence: (const char *)aName
          forSequence: aSeq
         withFeedFrom: anObj 
          andSelector: (SEL)aSel : arg1
{
  id aGrapher;
  char argStr[20];
  int ARGN=0;
  int argint;  
  
  argint = (long int)arg1;
  sprintf(argStr,"%d",argint);

  if (graphics)
    {
      id anElement;
      
      anElement = [graph createElement];
      [anElement setLabel: aName];
      [anElement setColor: graphColors[colorIdx++ % NUMCOLORS]];

      aGrapher = [ActiveGraph createBegin: [self getZone]];
      [aGrapher setElement: anElement];
      [aGrapher setDataFeed: anObj]; 
      [aGrapher setProbedSelector: aSel];
      aGrapher = [aGrapher createEnd];
      [aGrapher setArg: ARGN ToString: strdup(argStr)]; 
      
      [aSeq setActiveGrapher: aGrapher];    
    }

  if (fileOutput)
    {
      id aFileObj;
      const char *fName = NULL;
      char newName[20];

      // fName = sequence_graph_filename(fileName, aName);
      //aFileObj = [OutFile create: [self getZone] withName: fName];
      aFileObj = [OutFile create: [self getZone] setName: fName];
      aGrapher = [ActiveOutFile createBegin: [self getZone]];
      [aGrapher setFileObject: aFileObj];
      [aGrapher setDataFeed: anObj]; 
      [aGrapher setProbedSelector: aSel];
      aGrapher = [aGrapher createEnd];
      strcpy(newName,argStr);
      //[aGrapher setArg: ARGN ToString: strdup(argStr)]; 
      [aGrapher setArg: ARGN ToString: newName];
      [aSeq setActiveOutFile: aGrapher];    
      
    }
  
  [sequenceList addLast: aSeq];
  
  return self;
}

- createSequence: (const char *)aName
    withFeedFrom: anObj 
     andSelector: (SEL)aSel : arg1
{
  id aSeq;
  
  aSeq = [EZSequence create: [self getZone]];

  [self createGraphSequence: aName forSequence: aSeq
        withFeedFrom: anObj andSelector: aSel : arg1];
  
  return aSeq;
}


@end

