// Heatbugs application. Copyright (C) 1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// The HeatbugObserverSwarm is a swarm of objects set up to observe a
// Heatbugs model when the graphical interface is running. The most
// important object is the heatbugModelSwarm, but we also have
// graphical windows and data analysis and stuff.

#import <simtoolsgui.h>
#import <analysis.h> // EZGraph
#import "ModelSwarm.h"
#import "NewEZGraph.h"
#import <simtoolsgui/GUISwarm.h>

@interface ObserverSwarm: GUISwarm
{
  int displayFrequency;				// one parameter: update freq

  id displayActions;				// schedule data structs
  id displaySchedule;

  id stopSchedule;

  ModelSwarm *modelSwarm;	  	// the Swarm we're observing

  // Lots of display objects. First, widgets

  id <Colormap> colormap;			// allocate colours
  id <ZoomRaster> worldRaster;			// 2d display widget
  id <EZGraph>  summaryGraph, entropyGraph;			// graphing widget
  NewEZGraph * opinionGraph;
  // Now, higher order display and data objects
	
  id <Object2dDisplay> featureDisplay;	        // display the heatbugs
  id <List> rasterList, featureDisplayList;

}

// Methods overriden to make the Swarm.

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

- stopRunning;

- drawFeature: (int) f PointX: (int) posX Y: (int) posY Color: (int) type ;

- drawWorld: r;

//- graphBug: aBug;
@end
